import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class NinjaAttacker extends Actor
{
    // Attribute: Geschwindigkeit festlegen
    private int speed;

    // Konstruktor
    public NinjaAttacker()
    {
        this.speed = 10;
    }

    public void addedToWorld(World w)
    /*
     * Diese Methode ist Greenfoot-spezifisch. Sie wird ausgeführt,
     * sobald die Welt erzeugt ist.
     * Wenn wir im Konstruktor schreiben "this.getWorld().getWidth()", dann
     * erhalten wir eine Fehlermeldung, denn das Objekt this ist ja noch gar
     * nicht auf der Welt. Deshalb verwenden wir in solchen Fällen die
     * addedToWorld(World xyz)-Methode; unter xyz können wir dann auf das aktuelle
     * Objekt der Weltklasse zugreifen.
     */
    {      
        this.setLocation(w.getWidth() - 40, w.getHeight() - Fujiyama.groundHeight - this.getImage().getHeight()/2);
    }

    public void act()
    {
        this.bewegen();
        this.checkKollisionMitPlayer();
        this.checkRandkollision();
    }

    public void checkKollisionMitPlayer()
    {
        if(this.isTouching(Player.class))
        {
            Greenfoot.playSound("dying sound 4 (long).wav");
            this.getWorld().showText("Game over", this.getWorld().getWidth()/2, this.getWorld().getHeight()/2);
            Greenfoot.stop();
        }
    }

    public void bewegen()
    {
        this.move(-this.speed);
    }

    public void checkRandkollision()
    {
        if(this.isAtEdge())
        {
            // Hole dir eine Liste aller Player-Objekte von der Welt und nimm das erste
            // (get(0)).
            // Listen können wir noch nicht, deshalb nehmen Sie es erst mal so hin.
            Player p = (Player)this.getWorld().getObjects(Player.class).get(0);
            
            // die Methode punkteErhoehen() vom Playerobjekt ausführen:
            p.punkteErhoehen();
            
            this.getWorld().removeObject(this);   
        }
    }
}
